/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.4 - Sun, 20 Jan 2019 13:43:24 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ekvdefs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int ekvtrunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = ekvnextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = ekvinstances(model); here != NULL ; here = ekvnextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_g_b, ckt, timeStep);
            CKTterr(here->state_g_di, ckt, timeStep);
            CKTterr(here->state_g_si, ckt, timeStep);
            CKTterr(here->state_b_g, ckt, timeStep);
            CKTterr(here->state_b_di, ckt, timeStep);
            CKTterr(here->state_b_si, ckt, timeStep);
            CKTterr(here->state_si_g, ckt, timeStep);
            CKTterr(here->state_di_g, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->ekvname,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
