/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.4 - Sun, 20 Jan 2019 13:43:29 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "hicum0defs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int hicum0trunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  hicum0model *model = (hicum0model*)inModel;
  hicum0instance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = hicum0nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = hicum0instances(model); here != NULL ; here = hicum0nextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_tnode_GND, ckt, timeStep);
            CKTterr(here->state_b_e, ckt, timeStep);
            CKTterr(here->state_b_ci, ckt, timeStep);
            CKTterr(here->state_s_ci, ckt, timeStep);
            CKTterr(here->state_bi_ci, ckt, timeStep);
            CKTterr(here->state_bi_ei, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->hicum0name,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
