/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.4 - Sun, 20 Jan 2019 13:43:37 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "hicum2defs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int hicum2trunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  hicum2model *model = (hicum2model*)inModel;
  hicum2instance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = hicum2nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = hicum2instances(model); here != NULL ; here = hicum2nextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_xf_GND, ckt, timeStep);
            CKTterr(here->state_xf2_GND, ckt, timeStep);
            CKTterr(here->state_xf1_GND, ckt, timeStep);
            CKTterr(here->state_tnode_GND, ckt, timeStep);
            CKTterr(here->state_si_s, ckt, timeStep);
            CKTterr(here->state_si_ci, ckt, timeStep);
            CKTterr(here->state_bp_e, ckt, timeStep);
            CKTterr(here->state_b_e, ckt, timeStep);
            CKTterr(here->state_bp_ei, ckt, timeStep);
            CKTterr(here->state_bp_bi, ckt, timeStep);
            CKTterr(here->state_bp_ci, ckt, timeStep);
            CKTterr(here->state_b_ci, ckt, timeStep);
            CKTterr(here->state_bi_ci, ckt, timeStep);
            CKTterr(here->state_bi_ei, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->hicum2name,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
