/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.4 - Sun, 20 Jan 2019 13:29:17 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "psp102defs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int psp102trunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  psp102model *model = (psp102model*)inModel;
  psp102instance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = psp102nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = psp102instances(model); here != NULL ; here = psp102nextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_NOI_GND, ckt, timeStep);
            CKTterr(here->state_B_D, ckt, timeStep);
            CKTterr(here->state_B_S, ckt, timeStep);
            CKTterr(here->state_G_B, ckt, timeStep);
            CKTterr(here->state_G_D, ckt, timeStep);
            CKTterr(here->state_G_S, ckt, timeStep);
            CKTterr(here->state_D_S, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->psp102name,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
